HEADER = " === [HELP] %s" % ("="*40)

def runApps(args, apps=None):
	if apps is None:
		apps = findApps()
	for app in apps:
		if app.matches(args):
			return app.main()
	showHelp(apps)

# === PRIVATE ===

def showHelp(apps):
	print(HEADER)
	for app in apps:
		print(app.doc())

def findApps():
	from importlib import import_module
	from os import listdir
	from fnmatch import fnmatch
	from project.Path import Path
	d = Path.start(__file__)
	appfold = "apps"
	appsDir = d + appfold # path to apps.apps
	pkg = "apps.%s" % appfold
	apps  = []
	for py in sorted(listdir(appsDir)):
		if fnmatch(py, "*App.py"):
			name = "%s.%s" % (pkg, py[:-3])
			app = import_module(name).App()
			apps.append(app)
	return apps
