from ..BaseApp import BaseApp
from datafile.InstalledLog import InstalledLog
from Config import INSTALLED_F

NO_PACKAGES = "No packages are installed."

class App(BaseApp):
	"Lists all installed packages"
	
	def main(self):
		with InstalledLog(INSTALLED_F) as f:
			packages = f.show()
			if not packages:
				print(NO_PACKAGES)
			else:
				for pkg in packages:
					print(pkg)
	
	def options(self):
		return ["--list"]
