from filesys.tools import parse
from os import path
from TopLevelError import TopLevelError

class Requirements:

	class FormatError(TopLevelError):
		"Expected 1 backslash in package name {pkg}."

	class Requirement:
		def __init__(self, parts):
			(
				self.author,
				self.package,
			) = parts
			self.folder = self.package.lower()
		
		def __str__(self):
			return "/".join([self.author, self.package])
	
	@staticmethod
	def parse(pkgname):
		parts = pkgname.split("/")
		if len(parts) != 2:
			raise Requirements.FormatError(pkg=pkgname)
		return Requirements.Requirement(parts)
