from fnmatch import fnmatch
from os import path, listdir

from .tools import removepath

def exclude(root, includes, excludes):
	for f in rmblob(root, includes, excludes):
		removepath(f)

# === PRIVATE ===

def rmblob(p, includes, excludes):
	if match(p, excludes):
		yield p
	else:
		if path.isdir(p):
			for f in rmfolder(p, includes, excludes):
				yield f
		else:
			if not match(p, includes):
				yield p

def rmfolder(p, includes, excludes):
	for ff in listdir(p):
		newp = path.join(p, ff)
		for f in rmblob(newp, includes, excludes):
			yield f
	if listdir(p) == []: # if nothing in folder.
		yield p

def match(p, patterns):
	for pattern in patterns:
		if fnmatch(p, pattern):
			return True
	return False
