from TopLevelError import TopLevelError

from os import path, rename
from shutil import rmtree

from .tools import removepath

class NonExistentSubpackage(TopLevelError):
	"Error: expected subpackage {pkg}."

def extract(subpkg, pkg):
	subname = path.join(pkg, subpkg)
	if not path.isdir(subname):
		raise NonExistentSubpackage(pkg=subname)
	dname = path.dirname(pkg)
	temp = makeUniqueTempFolder(dname, subpkg)
	dst = path.join(dname, subpkg)
	rename(subname, temp)
	rmtree(pkg)
	rename(temp, dst)

def makeUniqueTempFolder(dname, subpkg):
	folder = path.join(dname, ".temp_" + subpkg)
	while path.isdir(folder):
		folder += "_"
	return folder
