from os import path, makedirs, remove, fsync
from shutil import rmtree

def parse(fname):
	with open(fname, "r") as f:
		for line in f:
			yield line.strip()

def openfile(fname, mode):
	dname = path.dirname(fname)
	if dname and not path.isdir(dname):
		makedirs(dname)
	return open(fname, mode)

def write(fname, msg):
	with openfile(fname, "w") as f:
		f.write(msg)
		fsync(f.fileno())

def removepath(p):
	if path.isdir(p):
		rmtree(p)
	else:
		remove(p)
