def flushLongDocument(s, top, bottom=None):
	lines = s.split("\n")
	if bottom is None:
		bottom = top
	if top + bottom < len(lines):
		out = showCutoff(lines, top, bottom)
	else:
		out = showAll(lines)
	return out
	
# ========== PRIVATE HELPERS ============================== 

def showSkipSymbol(arrow):
	return "\t" + "\n\t".join(arrow)

UP_ARROW = showSkipSymbol(["^", "|", "|"])
DW_ARROW = showSkipSymbol(["|", "|", "v"])

def showAll(lines):
	return "\n".join(lines)

def showCutoff(lines, top, bottom):
	output = lines[:top]
	output.append(UP_ARROW)

	skippedNum = len(lines) - top - bottom
	skipped = "\t+--(skipped %d lines)" % skippedNum
	output.append(skipped)

	output.append(DW_ARROW)
	output.extend(lines[-bottom:])
	return "\n".join(output)
