from .LongDocument import flushLongDocument
from .Process import Process

class Failure(Exception): 
	"Process returned non-zero code."
	def __init__(self):
		Exception.__init__(self, self.__doc__)

class ProcessReport:
	def __init__(self, cmdStr):
		self.process = Process(cmdStr.split(" "))
		self.command = cmdStr
		self.results = None
		self.warning = None

	def obtainResults(self):
		assert self.results is None
		self.results = list(self.process.iterResult())

	def checkError(self):
		self.warning = self.process.getError()
		error = flushLongDocument(self.warning, top=12, bottom=8)
		if error:
			print(error)
		code = self.process.getCode()
		assert code is not None
		if code != 0:
			raise Failure()
