from filesys.tools import parse
from TopLevelError import TopLevelError
from os import path

class MissingConfigFile(TopLevelError):
	"{f} is not found in the current directory."

class ConfigFile:
	def __init__(self, fname):
		self.fname = fname
		self.data = {}
		self.parse()
	
	def get(self, key):
		if key in self.data:
			return self.data[key]
		else:
			return []
	
	# === PRIVATE ===
	
	def parse(self):
		if not path.isfile(self.fname):
			raise MissingConfigFile(f=self.fname)
		for opt, args in map(self.parseLine, parse(self.fname)):
			self.data[opt] = args
	
	def parseLine(self, line):
		parts = line.split("=")
		opt = parts[0].strip()
		arg = "=".join(parts[1:])
		args = filter(None, map(str.strip, arg.split(" ")))
		return opt.strip(), list(args)
