# Note: this should rely on as few dependencies as possible.
from os import path, fsync
import json

class VersionManager:
	def __init__(self, fname):
		self.fname = fname
		self.version = ["0", "0", "0"]
		self.parse()
	
	def getVersion(self):
		return ".".join(self.version)
	
	def update(self):
		assert len(self.version) == 3
		sv = self.version[-1]
		self.version[-1] = str(int(sv) + 1)
		with open(self.fname, "w") as f:
			f.write(json.dumps(self.version))
			fsync(f.fileno())
	
	# === PRIVATE ===
	
	def parse(self):
		if path.isfile(self.fname):
			with open(self.fname, "r") as f:
				self.version = json.loads(f.read().strip())
	
