from TopLevelError import TopLevelError
from Config import CLONE_CMD, GIT_URL
from process.Command import Command
from process.ProcessReport import Failure

MAX_TRIES = 3
DOWNLOADING = "Downloading from %s%s..."
RETRY = " (retry %d)"

class DownloadError(TopLevelError):
	"Download from {url} was not successful."

def download(pkgname, tries=0, retry=""):
	url = GIT_URL.format(package=pkgname)
	print(DOWNLOADING % (url, retry))
	cmd = Command(CLONE_CMD)
	try:
		cmd.run(url=url)
	except Failure as e:
		tries += 1
		if tries < MAX_TRIES:
			download(pkgname, tries, RETRY % tries)
		else:
			raise DownloadError(url=url)

