from setuptools import setup

from gitinstaller.Config import NAME, BIN, VERSION_F
from gitinstaller.filesys.findfile import iterfile
from gitinstaller.project.VersionManager import VersionManager

def get_pymodules(root):
	out = []
	for f in iterfile(root, ["*.py"], ["*/tests", "*/__pycache__"]):
		out.append(f[:-3]) # no ".py"
	return out

setup(name=NAME,
	  version=VersionManager(VERSION_F).getVersion(),
	  description="Installer for packages hosted on GitHub.",
	  url="https://github.com/ychnlgy/GitInstaller",
	  author="Yuchen Li",
	  author_email="ychnlgy@gmail.com",
	  license="MIT",
	  py_modules=get_pymodules("gitinstaller"),
	  scripts=[BIN],
	  zip_safe=False)
